xref: /openbmc/linux/scripts/link-vmlinux.sh (revision 7a2eb736)
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
11#
12# vmlinux
13#   ^
14#   |
15#   +--< $(KBUILD_VMLINUX_OBJS)
16#   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17#   |
18#   +--< $(KBUILD_VMLINUX_LIBS)
19#   |    +--< lib/lib.a + more
20#   |
21#   +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33# Nice output in kbuild format
34# Will be supressed by "make -s"
35info()
36{
37	if [ "${quiet}" != "silent_" ]; then
38		printf "  %-7s %s\n" "${1}" "${2}"
39	fi
40}
41
42# Link of vmlinux.o used for section mismatch analysis
43# ${1} output file
44modpost_link()
45{
46	local objects
47
48	objects="--whole-archive				\
49		${KBUILD_VMLINUX_OBJS}				\
50		--no-whole-archive				\
51		--start-group					\
52		${KBUILD_VMLINUX_LIBS}				\
53		--end-group"
54
55	${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
56}
57
58# Link of vmlinux
59# ${1} - output file
60# ${@:2} - optional extra .o files
61vmlinux_link()
62{
63	local lds="${objtree}/${KBUILD_LDS}"
64	local objects
65
66	if [ "${SRCARCH}" != "um" ]; then
67		objects="--whole-archive			\
68			${KBUILD_VMLINUX_OBJS}			\
69			--no-whole-archive			\
70			--start-group				\
71			${KBUILD_VMLINUX_LIBS}			\
72			--end-group				\
73			${@:2}"
74
75		${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} -o ${1}	\
76			-T ${lds} ${objects}
77	else
78		objects="-Wl,--whole-archive			\
79			${KBUILD_VMLINUX_OBJS}			\
80			-Wl,--no-whole-archive			\
81			-Wl,--start-group			\
82			${KBUILD_VMLINUX_LIBS}			\
83			-Wl,--end-group				\
84			${@:2}"
85
86		${CC} ${CFLAGS_vmlinux} -o ${1}			\
87			-Wl,-T,${lds}				\
88			${objects}				\
89			-lutil -lrt -lpthread
90		rm -f linux
91	fi
92}
93
94# generate .BTF typeinfo from DWARF debuginfo
95# ${1} - vmlinux image
96# ${2} - file to dump raw BTF data into
97gen_btf()
98{
99	local pahole_ver
100	local bin_arch
101
102	if ! [ -x "$(command -v ${PAHOLE})" ]; then
103		info "BTF" "${1}: pahole (${PAHOLE}) is not available"
104		return 1
105	fi
106
107	pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
108	if [ "${pahole_ver}" -lt "113" ]; then
109		info "BTF" "${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.13"
110		return 1
111	fi
112
113	info "BTF" ${2}
114	vmlinux_link ${1}
115	LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
116
117	# dump .BTF section into raw binary file to link with final vmlinux
118	bin_arch=$(${OBJDUMP} -f ${1} | grep architecture | \
119		cut -d, -f1 | cut -d' ' -f2)
120	${OBJCOPY} --dump-section .BTF=.btf.vmlinux.bin ${1} 2>/dev/null
121	${OBJCOPY} -I binary -O ${CONFIG_OUTPUT_FORMAT} -B ${bin_arch} \
122		--rename-section .data=.BTF .btf.vmlinux.bin ${2}
123}
124
125# Create ${2} .o file with all symbols from the ${1} object file
126kallsyms()
127{
128	info KSYM ${2}
129	local kallsymopt;
130
131	if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
132		kallsymopt="${kallsymopt} --all-symbols"
133	fi
134
135	if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
136		kallsymopt="${kallsymopt} --absolute-percpu"
137	fi
138
139	if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
140		kallsymopt="${kallsymopt} --base-relative"
141	fi
142
143	local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
144		      ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
145
146	local afile="`basename ${2} .o`.S"
147
148	${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
149	${CC} ${aflags} -c -o ${2} ${afile}
150}
151
152# Create map file with all symbols from ${1}
153# See mksymap for additional details
154mksysmap()
155{
156	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
157}
158
159sortextable()
160{
161	${objtree}/scripts/sortextable ${1}
162}
163
164# Delete output files in case of error
165cleanup()
166{
167	rm -f .btf.*
168	rm -f .tmp_System.map
169	rm -f .tmp_kallsyms*
170	rm -f .tmp_vmlinux*
171	rm -f System.map
172	rm -f vmlinux
173	rm -f vmlinux.o
174}
175
176on_exit()
177{
178	if [ $? -ne 0 ]; then
179		cleanup
180	fi
181}
182trap on_exit EXIT
183
184on_signals()
185{
186	exit 1
187}
188trap on_signals HUP INT QUIT TERM
189
190#
191#
192# Use "make V=1" to debug this script
193case "${KBUILD_VERBOSE}" in
194*1*)
195	set -x
196	;;
197esac
198
199if [ "$1" = "clean" ]; then
200	cleanup
201	exit 0
202fi
203
204# We need access to CONFIG_ symbols
205. include/config/auto.conf
206
207# Update version
208info GEN .version
209if [ -r .version ]; then
210	VERSION=$(expr 0$(cat .version) + 1)
211	echo $VERSION > .version
212else
213	rm -f .version
214	echo 1 > .version
215fi;
216
217# final build of init/
218${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
219
220#link vmlinux.o
221info LD vmlinux.o
222modpost_link vmlinux.o
223
224# modpost vmlinux.o to check for section mismatches
225${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
226
227info MODINFO modules.builtin.modinfo
228${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
229
230btf_vmlinux_bin_o=""
231if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
232	if gen_btf .tmp_vmlinux.btf .btf.vmlinux.bin.o ; then
233		btf_vmlinux_bin_o=.btf.vmlinux.bin.o
234	fi
235fi
236
237kallsymso=""
238kallsyms_vmlinux=""
239if [ -n "${CONFIG_KALLSYMS}" ]; then
240
241	# kallsyms support
242	# Generate section listing all symbols and add it into vmlinux
243	# It's a three step process:
244	# 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
245	#     but __kallsyms is empty.
246	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
247	#     the right size
248	# 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
249	#     the right size, but due to the added section, some
250	#     addresses have shifted.
251	#     From here, we generate a correct .tmp_kallsyms2.o
252	# 3)  That link may have expanded the kernel image enough that
253	#     more linker branch stubs / trampolines had to be added, which
254	#     introduces new names, which further expands kallsyms. Do another
255	#     pass if that is the case. In theory it's possible this results
256	#     in even more stubs, but unlikely.
257	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
258	#     other bugs.
259	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
260	#
261	# a)  Verify that the System.map from vmlinux matches the map from
262	#     ${kallsymso}.
263
264	kallsymso=.tmp_kallsyms2.o
265	kallsyms_vmlinux=.tmp_vmlinux2
266
267	# step 1
268	vmlinux_link .tmp_vmlinux1 ${btf_vmlinux_bin_o}
269	kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
270
271	# step 2
272	vmlinux_link .tmp_vmlinux2 .tmp_kallsyms1.o ${btf_vmlinux_bin_o}
273	kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
274
275	# step 3
276	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms1.o)
277	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms2.o)
278
279	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
280		kallsymso=.tmp_kallsyms3.o
281		kallsyms_vmlinux=.tmp_vmlinux3
282
283		vmlinux_link .tmp_vmlinux3 .tmp_kallsyms2.o ${btf_vmlinux_bin_o}
284		kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
285	fi
286fi
287
288info LD vmlinux
289vmlinux_link vmlinux "${kallsymso}" "${btf_vmlinux_bin_o}"
290
291if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
292	info SORTEX vmlinux
293	sortextable vmlinux
294fi
295
296info SYSMAP System.map
297mksysmap vmlinux System.map
298
299# step a (see comment above)
300if [ -n "${CONFIG_KALLSYMS}" ]; then
301	mksysmap ${kallsyms_vmlinux} .tmp_System.map
302
303	if ! cmp -s System.map .tmp_System.map; then
304		echo >&2 Inconsistent kallsyms data
305		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
306		exit 1
307	fi
308fi
309